SystemOrganization addCategory: #Spec!

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 17:27'!
getIndexSelector: aNumber

	getIndexSelector := aNumber! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 22:19'!
initialize

	super initialize.
	self initForKeystrokes.! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 17:27'!
setIndexSelector: aNumber

	setIndexSelector := aNumber! !

!PluggableListMorph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 16:00'!
update: aSymbol 
	"Refer to the comment in View|update:."

	aSymbol == getListSelector
		ifTrue: [
			self updateList.
			^ super update: aSymbol ].
	aSymbol == getIndexSelector
		ifTrue: [
			self selectionIndex: self getCurrentSelectionIndex.
			^ super update: aSymbol ].
	aSymbol == #allSelections
		ifTrue: [
			self selectionIndex: self getCurrentSelectionIndex.
			self changed.
			^ super update: aSymbol ].! !

!Morph methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/14/2011 16:32'!
addMorphWrapper: aMorphWrapper
	
	
	aMorphWrapper addIn: self.! !

Model subclass: #SelectionValueHolder
	instanceVariableNames: 'index selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!SelectionValueHolder commentStamp: '<historical>' prior: 0!
A SelectionValueHolder is a value holder especially designed to contains a list selection (an index + an object)!

!SelectionValueHolder class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 21:00'!
index: indexValueHolder selection: selectionValueHolder

	^ self new
		index: indexValueHolder;
		selection: selectionValueHolder;
		yourself! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/17/2011 20:09'!
contents

	^ {index. selection}! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 20:57'!
index

	^ index! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 20:59'!
index: anIndex

	index := anIndex.
	self changed: #index! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/17/2011 20:14'!
initialize

	super initialize.
	index := 0 asValueHolder.
	selection := nil asValueHolder.
	
	index addDependent: self.
	selection addDependent: self.! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 20:57'!
selection

	^ selection! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 20:58'!
selection: aSelection

	selection := aSelection.
	self changed: #selection! !

!SelectionValueHolder methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/17/2011 20:15'!
update: aSymbol

	self contentsChanged! !

ValueHolder subclass: #ComposableValueHolder
	instanceVariableNames: 'block originalValueHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ComposableValueHolder commentStamp: '<historical>' prior: 0!
A ComposableValueHolder is a value holder based on another value holder which content is calculated regarding the original value holder content!

!ComposableValueHolder class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
block: block originalValueHolder: originalValueHolder

	^ self new
		block: block;
		originalValueHolder: originalValueHolder;
		yourself! !

!ComposableValueHolder class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
on: originalValueHolder do: block

	^ self new
		block: block;
		originalValueHolder: originalValueHolder;
		yourself! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
block

	^ block! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
block: anObject
	
	block := anObject! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 18:06'!
originalValueHolder

	^ originalValueHolder! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:20'!
originalValueHolder: aValueHolder
	
	originalValueHolder := aValueHolder.
	aValueHolder addDependent: self.
	self update: #update! !

!ComposableValueHolder methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:59'!
update: aSymbol

	| args |
	args := self originalValueHolder contents.
	args isArray
		ifTrue: [ self contents: (self block valueWithArguments: args)]
		ifFalse: [ self contents: (self block value: args)].! !

!ValueHolder class methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 17:52'!
contents: aValue
	
	^ self new
		contents: aValue;
		yourself! !

Object subclass: #ComposableModel
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ComposableModel commentStamp: '<historical>' prior: 0!
ComposableModel is an abstract which represent a applicative model made to be composed with other ComposableModel!

ComposableModel subclass: #ClassMethodList
	instanceVariableNames: 'listHolder listModel listModel2 selectionHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ClassMethodList commentStamp: '<historical>' prior: 0!
| t |
t:= ClassMethodList new.
t openWithSpec.
t listHolder contents: (Smalltalk allClasses).!

!ClassMethodList classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 21:54'!
internSpec

	^{ #PanelMorph.
			#changeTableLayout.
			#listDirection:. #rightToLeft.
			#addMorph:. {#model. #listModel. #internSpec.}.
			#addMorph:. {#model. #listModel2. #internSpec.}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!ClassMethodList classSide methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 11/17/2011 21:28'!
internSpec2

	^{ #PanelMorph.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ 	#model. #listModel. #internSpec.	}.
											#frame:.	(	0@0 corner: 0.5@1)	}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ 	#model. #listModel2. #internSpec.	}.
											#frame:.	(	0.5@0 corner: 1@1)	}.
			#hResizing:. 			#spaceFill.
			#vResizing:. 			#spaceFill}! !

!ClassMethodList classSide methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 11/17/2011 19:44'!
miniSpec

	^ { 	#model. #listModel. #windowSpec.	}! !

!ClassMethodList classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 21:56'!
title

	^ 'Class Method List'! !

!ClassMethodList classSide methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 11/17/2011 21:12'!
windowSpec2

	^{ #StandardWindow.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ 	#model. #listModel. #windowSpec.	}.
											#frame:.	(	0@0 corner: 0.5@1)	}.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	{ 	#model. #listModel2. #windowSpec.	}.
											#frame:.	(	0.5@0 corner: 1@1)	}.
			#title:.					'Test'											}! !

!ClassMethodList methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 11/17/2011 22:01'!
initialize
	| listHolder2 |
	
	super initialize.
	
	listHolder := {} asValueHolder.
	selectionHolder := SelectionValueHolder new.
	
	listModel := ListComposableModel indexHolder: selectionHolder listHolder: listHolder.
	
	listModel2 := ListComposableModel new.
	listHolder2 := ComposableValueHolder on: (listModel indexHolder) do: [:index :selection | selection contents ifNotNil: [:c | c methodDict keys sort ]].
	listModel2 listHolder: listHolder2.! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
listHolder

	^ listHolder! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 22:03'!
listHolder: anObject
	
	listHolder := anObject.
	listModel listHolder: anObject.! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
listModel

	^ listModel! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
listModel2

	^ listModel2! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
listModel2: anObject
	
	listModel2 := anObject! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
listModel: anObject
	
	listModel := anObject! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
selectionHolder

	^ selectionHolder! !

!ClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:04'!
selectionHolder: anObject
	
	selectionHolder := anObject! !

!ComposableModel class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 11/17/2011 22:10'!
example
	| instance |
	instance := self new.
	instance openWithSpec.
	instance listHolder contents: (Smalltalk allClasses).! !

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 21:57'!
internSpec

	^ self subclassresponsibility! !

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:07'!
title
	
	^ 'Untitled window'! !

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:08'!
windowSpec

	^{ #StandardWindow.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.	self internSpec.
											#frame:.	(	0@0 corner: 1@1)	}.
			#title:.					self title}! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 21:13'!
internSpec

	^ self class internSpec! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 22:21'!
morph

	^ morph! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/7/2011 22:21'!
morph: anObject
	
	morph := anObject! !

!ComposableModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/17/2011 21:43'!
openMorphWithSpec

	^ (SpecInterpretor buildMorphFor: self) openInWorld! !

!ComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/17/2011 21:43'!
openWithSpec

	^ (SpecInterpretor buildWindowFor: self) openInWorld! !

!ComposableModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/17/2011 21:55'!
title

	^ 'Untitled Window'! !

!ComposableModel methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/17/2011 21:56'!
windowSpec

	^{ #StandardWindow.
			#addMorphWrapper:.	{	#MorphWrapper.
											#morph:.		self internSpec			.
											#frame:.	(	0@0 corner: 1@1)		}.
			#title:.					self title										}! !

ComposableModel subclass: #DoubleClassMethodList
	instanceVariableNames: 'classMethodList classMethodList2 listHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!DoubleClassMethodList commentStamp: '<historical>' prior: 0!
| t |
t:= DoubleClassMethodList new.
t openWithSpec.
t listHolder contents: (Smalltalk allClasses).!

!DoubleClassMethodList classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 21:58'!
internSpec

	^{ #PanelMorph.
			#changeTableLayout.
			#listDirection:. #bottomToTop.
			#addMorph:. {#model. #classMethodList. #internSpec.}.
			#addMorph:. {#model. #classMethodList2. #internSpec.}.
			#vResizing:. #spaceFill.
			#hResizing:. #spaceFill.}.! !

!DoubleClassMethodList classSide methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:09'!
title

	^ 'Double double lists'! !

!DoubleClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:51'!
classMethodList

	^ classMethodList! !

!DoubleClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:51'!
classMethodList2

	^ classMethodList2! !

!DoubleClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:51'!
classMethodList2: anObject
	
	classMethodList2 := anObject! !

!DoubleClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:51'!
classMethodList: anObject
	
	classMethodList := anObject! !

!DoubleClassMethodList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 22:31'!
initialize
	| listHolder2 |


	super initialize.
	classMethodList := ClassMethodList new.
	listHolder := classMethodList listHolder.
	
	classMethodList2 := ClassMethodList new.
	
	listHolder2 := ComposableValueHolder on: (classMethodList selectionHolder) do: [:index :selection | selection contents ifNotNil: [:c | Smalltalk allClasses select:[:e | e category = c category ]]].
	classMethodList2 listHolder: listHolder2! !

!DoubleClassMethodList methodsFor: 'entry point' stamp: 'BenjaminVanRyseghem 11/17/2011 22:04'!
listHolder

	^ listHolder! !

!DoubleClassMethodList methodsFor: 'entry point' stamp: 'BenjaminVanRyseghem 11/17/2011 22:05'!
listHolder: aValueHolder

	listHolder := aValueHolder.
	classMethodList listHolder: listHolder.! !

ComposableModel subclass: #ListComposableModel
	instanceVariableNames: 'indexHolder listHolder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!ListComposableModel commentStamp: '<historical>' prior: 0!
A ListComposableModel is an applicative model which handle a basic list.

| t |
t:= ListComposableModel new.
t openWithSpec.
t listHolder contents: (Smalltalk allClasses).!

!ListComposableModel class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/7/2011 19:22'!
indexHolder: indexHolder listHolder: listHolder

	^ self new
		indexHolder: indexHolder;
		listHolder: listHolder;
		yourself! !

!ListComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 21:13'!
internSpec

	^ {#PluggableListMorph.
	    		#model:. #model.
			#getListSelector:. #getList.
			#getIndexSelector:. #getIndex.
			#setIndexSelector:. #setIndex:.
			#hResizing:. 			#spaceFill.
			#vResizing:. 			#spaceFill}! !

!ListComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 11/17/2011 22:09'!
title

	^ 'List'! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 11/17/2011 20:12'!
getIndex

	^ self indexHolder index contents! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 11/7/2011 19:29'!
getList

	^ self listHolder contents! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 17:53'!
indexHolder

	^ indexHolder! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:06'!
indexHolder: anObject
	
	indexHolder := anObject.
	anObject addDependent: self.
	self changed: #getIndex.! !

!ListComposableModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 11/17/2011 20:07'!
initialize

	super initialize.
	self indexHolder: SelectionValueHolder new.
	self listHolder: Array new asValueHolder! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 17:53'!
listHolder

	^ listHolder! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:06'!
listHolder: anObject
	
	listHolder := anObject.
	anObject addDependent: self.
	self changed: #getList! !

!ListComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 11/14/2011 16:40'!
setIndex: anIndex

	self indexHolder index contents: anIndex.
	self indexHolder selection contents: (self getList at: anIndex ifAbsent: [ nil ]).
	self changed: #getIndex! !

!ListComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/17/2011 20:15'!
update: aSymbol

	self changed: #getList! !

Object subclass: #MorphWrapper
	instanceVariableNames: 'layout morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!MorphWrapper commentStamp: '<historical>' prior: 0!
A MorphWrapper is used to wrap a morph with a layout in the goal to be easily added to another morph!

!MorphWrapper class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/14/2011 16:27'!
morph: morph layout: layout 

	^ self new
		layout: layout;
		morph: morph;
		yourself! !

!MorphWrapper methodsFor: 'adding' stamp: 'BenjaminVanRyseghem 11/14/2011 16:31'!
addIn: aContainer

	aContainer
		addMorph: morph
		fullFrame: layout! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:38'!
frame: relFrame
	| frame |
	frame := LayoutFrame new.
	frame 
		leftFraction: relFrame left; 
		rightFraction: relFrame right; 
		topFraction: relFrame top; 
		bottomFraction: relFrame bottom.
	layout := frame! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:38'!
fullFrame: anObject
	
	layout := anObject! !

!MorphWrapper methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/14/2011 16:27'!
morph: anObject
	
	morph := anObject! !

!Object methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 20:48'!
asValueHolder

	^ ValueHolder contents: self! !

!Object methodsFor: '*Spec' stamp: 'BenjaminVanRyseghem 11/7/2011 20:47'!
update: aParameter 
	"Receive a change notice from an object of whom the receiver is a 
	dependent. The default behavior is to do nothing; a subclass might want 
	to change itself in some way."

	self triggerEvent: #changed.
	^ self! !

Object subclass: #SpecInterpretor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec'!

!SpecInterpretor commentStamp: '<historical>' prior: 0!
#model is a magic world to swap the symbol to the model object
!

!SpecInterpretor classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/17/2011 21:42'!
buildMorphFor: aComposableModel
	
	^ self interpretASpec: aComposableModel class internSpec model: aComposableModel! !

!SpecInterpretor classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/17/2011 21:42'!
buildWindowFor: aComposableModel
	
	^ self interpretASpec: aComposableModel class windowSpec model: aComposableModel! !

!SpecInterpretor classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/8/2011 14:26'!
classKeys

	^ Smalltalk keys! !

!SpecInterpretor classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/7/2011 17:09'!
convertSymbolOfClassToInstance: aSymbol

	^ (Smalltalk at: aSymbol) new! !

!SpecInterpretor classSide methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 11/17/2011 21:15'!
interpretASpec: aSpec model: aModel
	| instance index |

	aSpec ifNil: [ ^ nil ].
	(aSpec isCollection and: [aSpec isSequenceable]) ifFalse: [ ^ aSpec ].
	aSpec isString ifTrue: [ 
			^ aSpec == #model
				ifTrue: [ aModel ]
				ifFalse: [ 
					(self classKeys identityIncludes: aSpec)
						ifTrue: [ self convertSymbolOfClassToInstance: aSpec ]
						ifFalse: [ aSpec ]]].

	" aSpec is an Array "
	instance := self interpretASpec: aSpec first model: aModel.
	
	index := 2.	
	
	[ index <= aSpec size ]
		whileTrue: [ | selector numArgs args newInstance result |
			selector := aSpec at: index.
			numArgs := selector numArgs.
			args := aSpec copyFrom: index + 1 to: index + numArgs.
			args := args collect: [:each | self interpretASpec: each model: aModel].
			index := index + numArgs + 1.
			newInstance := instance perform: selector withArguments: args.
			index > aSpec size
				ifTrue: [
					(( instance respondsTo: #model) and: [ instance model respondsTo: #morph: ])
						ifTrue: [ instance model morph: instance ].
					^ self interpretASpec: newInstance model: instance ].
			instance := newInstance].
	self halt.
	^ instance! !
